package org.ifmo.refrigerator.components;

/**
 *  ""
 */
public class Frazil extends BaseComponent {
    private final static int FRAZIL_INCREASING = 1;
    private final static int FRAZIL_DELAY = 5;
    public final static int BAD_MIN = 90;
    public final static int MAX_FRAZIL = 100;

    private int frazil = 0;
    private int delay = 10;

    // 
    public Frazil(Content content) {
        super(content);
    }

    //   
    public int getFrazil() {
        return frazil;
    }

    //   
    public void setFrazil(int frazil) {
        if (frazil > MAX_FRAZIL)
            frazil = MAX_FRAZIL;
        if (frazil > BAD_MIN)
            getContent().getFrazilController().overFrazil();
        else
            getContent().getFrazilController().normalFrazil();
        this.frazil = frazil;
    }

    //   
    public void timeEvent() {
        delay--;
        if (delay <= 0) {
            setFrazil(getFrazil() + FRAZIL_INCREASING);
            delay = FRAZIL_DELAY;
        }
    }
}

