package org.ifmo.refrigerator.components;

import org.ifmo.refrigerator.debug.AutomatLog;

/**
 *  " "
 */
public class FrazilController extends BaseAutomatComponent {

    // 
    public FrazilController(Content content) {
        super(content);
    }

    //  "    "
    public void normalFrazil() {
        A2(E1_NORMAL_FRAZIL);
    }

    //  "   "
    public void overFrazil() {
        A2(E2_OVER_FRAZIL);
    }

    //  " "
    public void cleanFrazil() {
        getContent().getFrazil().setFrazil(0);
        A2(E3_CLEAN_FRAZIL);
    }

    // 
    private static final int E1_NORMAL_FRAZIL = 1;
    private static final int E2_OVER_FRAZIL = 2;
    private static final int E3_CLEAN_FRAZIL = 3;

    // 
    private static final int Y0_NORMAL_FRAZIL = 0;
    private static final int Y1_OVER_FRAZIL = 1;

    //  
    private int Y = Y0_NORMAL_FRAZIL;

/**
 *  2
 */
    private void A2(int e) {
        int oldY = Y;
        switch (Y) {
            case Y0_NORMAL_FRAZIL:
                if (e == E1_NORMAL_FRAZIL)
                    ;
                else if (e == E2_OVER_FRAZIL) {
                    Y = Y1_OVER_FRAZIL;
                    z2();
                }
                break;

            case Y1_OVER_FRAZIL:
                if (e == E3_CLEAN_FRAZIL) {
                    Y = Y0_NORMAL_FRAZIL;
                    z1();
                }
                break;
        }
        if (Y != oldY)
            AutomatLog.transaction(2, getAutomatName(), oldY, Y);
    }

    //   "  " "
    private void z1() {
        getContent().getFrazilIndicator().Off();
    }

    //   "  " "
    private void z2() {
        getContent().getFrazilIndicator().On();
    }
}
