package org.ifmo.refrigerator.components;

import java.util.Timer;
import java.util.TimerTask;

/**
 *  ,          
 */
public class Quartz extends BaseComponent {
    // 
    private Timer timer = new Timer();

    public Quartz(Content content) {
        super(content);
    }

    //     
    public void run() {
        timer.schedule(new TimerTask() {
            public void run() {
                while (true) {
                    Content content = getContent();
                    content.getAir().timeEvent();
                    content.getAirFilter().timeEvent();
                    content.getAirFilterBrokenIndicator().timeEvent();
                    content.getBottomDoor().timeEvent();
                    content.getBottomIndicator().timeEvent();
                    content.getAirFilterIndicator().timeEvent();
                    content.getFrazil().timeEvent();
                    content.getFrazilController().timeEvent();
                    content.getFrazilIndicator().timeEvent();
                    content.getTopDoor().timeEvent();
                    content.getLoudSpeaker().timeEvent();
                    content.getTopIndicator().timeEvent();
                    content.getTopLamp().timeEvent();
                    content.getBottomLamp().timeEvent();
                    content.updateState();
                    try {
                        Thread.sleep(100);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        }, 0);
    }

}
