package org.ifmo.refrigerator.ui;

import java.awt.*;

/**
 *  " "
 */
public class ImageLoader {

    private static final String ICON_IMAGE_FILENAME = "org/ifmo/refrigerator/ui/img/Burger.gif";
    private static final String SCALE = "org/ifmo/refrigerator/ui/img/scale.jpg";
    private static final String DISPLAY_IMAGE_FILENAME = "org/ifmo/refrigerator/ui/img/display.jpg";
    private static final String TEMPERATURE_ACTIVE = "org/ifmo/refrigerator/ui/img/TempIceMenuActive.gif";
    private static final String CONDITIONER_ACTIVE = "org/ifmo/refrigerator/ui/img/ConditionerActive.gif";
    private static final String CONDITIONER_ACTIVE_STATE = "org/ifmo/refrigerator/ui/img/ConditionerActiveState.gif";
    private static final String CONDITIONER_FILTER_ACTIVE_STATE = "org/ifmo/refrigerator/ui/img/ConditionerFilterActive.gif";
    private static final String FREEZER_ICE_ACTIVE_STATE = "org/ifmo/refrigerator/ui/img/FreezerChamberIceActive.gif";
    private static final String FREEZER_DOOR_ACTIVE_STATE = "org/ifmo/refrigerator/ui/img/FreezerDoorOpenActive.gif";
    private static final String REFR_DOOR_ACTIVE_STATE = "org/ifmo/refrigerator/ui/img/RefrDoorOpenActive.gif";
    private static final String BREAK_FILTER_BUTTON_ON = "org/ifmo/refrigerator/ui/img/brakeFilterP.gif";
    private static final String FIX_FILTER_BUTTON_ON = "org/ifmo/refrigerator/ui/img/fixFilterP.gif";
    private static final String REMOVE_ICE_BUTTON = "org/ifmo/refrigerator/ui/img/removeIceP.gif";
    private static final String REFR_DOOR = "org/ifmo/refrigerator/ui/img/TdoorOp";
    public static final int REFR_DOOR_IMAGES_CNT = 4;
    private static final String MOROZ_DOOR = "org/ifmo/refrigerator/ui/img/BdoorOp";
    public static final int MOROZ_DOOR_IMAGES_CNT = 4;
    private static final String REFR_OPEN = "org/ifmo/refrigerator/ui/img/refrigeratorOpen.jpg";
    private static final String LIGHT_ON = "org/ifmo/refrigerator/ui/img/lighton.gif";
    private static final String LIGHT_OFF = "org/ifmo/refrigerator/ui/img/lightoff.gif";

    public Image imgIcon = null;
    public Image imgScale = null;
    public Image imgDisplay = null;
    public Image imgTemperatureActive = null;
    public Image imgConditionerActive = null;
    public Image imgConditionerActiveState = null;
    public Image imgConditionerFilterActiveState = null;
    public Image imgFreezerIceActiveState = null;
    public Image imgFreezerDoorActiveState = null;
    public Image imgRefrDoorActiveState = null;
    public Image imgBreakFilterButtonOn = null;
    public Image imgFixFilterButtonOn = null;
    public Image imgRemoveIceButtonOn = null;
    public Image imgRefrDoor[] = new Image[REFR_DOOR_IMAGES_CNT];
    public Image imgMorozDoor[] = new Image[MOROZ_DOOR_IMAGES_CNT];
    public Image imgRefrOpen = null;
    public Image imgLightOn = null;
    public Image imgLightOff = null;

    //    
    public ImageLoader(Toolkit toolkit) {
        imgDisplay = toolkit.createImage(DISPLAY_IMAGE_FILENAME);
        imgIcon = toolkit.createImage(ICON_IMAGE_FILENAME);
        imgScale = toolkit.createImage(SCALE);
        imgTemperatureActive = toolkit.createImage(TEMPERATURE_ACTIVE);
        imgConditionerActive = toolkit.createImage(CONDITIONER_ACTIVE);
        imgConditionerActiveState = toolkit.createImage(CONDITIONER_ACTIVE_STATE);
        imgConditionerFilterActiveState = toolkit.createImage(CONDITIONER_FILTER_ACTIVE_STATE);
        imgFreezerIceActiveState = toolkit.createImage(FREEZER_ICE_ACTIVE_STATE);
        imgFreezerDoorActiveState = toolkit.createImage(FREEZER_DOOR_ACTIVE_STATE);
        imgRefrDoorActiveState = toolkit.createImage(REFR_DOOR_ACTIVE_STATE);
        imgBreakFilterButtonOn = toolkit.createImage(BREAK_FILTER_BUTTON_ON);;
        imgFixFilterButtonOn = toolkit.createImage(FIX_FILTER_BUTTON_ON);
        imgRemoveIceButtonOn = toolkit.createImage(REMOVE_ICE_BUTTON);
        imgLightOn = toolkit.createImage(LIGHT_ON);
        imgLightOff = toolkit.createImage(LIGHT_OFF);

        for (int i = 0; i < REFR_DOOR_IMAGES_CNT; i++) {
            imgRefrDoor[i] = toolkit.createImage(REFR_DOOR + i + ".jpg");
        }
        for (int i = 0; i < MOROZ_DOOR_IMAGES_CNT; i++) {
            imgMorozDoor[i] = toolkit.createImage(MOROZ_DOOR + i + ".jpg");
        }
        imgRefrOpen = toolkit.createImage(REFR_OPEN);


        while (!toolkit.prepareImage(imgScale, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgDisplay, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgIcon, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgTemperatureActive, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgConditionerActive, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgConditionerActiveState, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgConditionerFilterActiveState, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgFreezerIceActiveState, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgFreezerDoorActiveState, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgRefrDoorActiveState, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgBreakFilterButtonOn, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgFixFilterButtonOn, 1, 1, null)) {
            sleep();
        }
        while (!toolkit.prepareImage(imgRemoveIceButtonOn, 1, 1, null)) {
                    sleep();
        }
        while (!toolkit.prepareImage(imgLightOn, 1, 1, null)) {
                    sleep();
        }
        while (!toolkit.prepareImage(imgLightOff, 1, 1, null)) {
                    sleep();
        }

        for (int i = 0; i < REFR_DOOR_IMAGES_CNT; i++) {
            while (!toolkit.prepareImage(imgRefrDoor[i], 1, 1, null)) {
                sleep();
            }
        }
        for (int i = 0; i < REFR_DOOR_IMAGES_CNT; i++) {
            while (!toolkit.prepareImage(imgMorozDoor[i], 1, 1, null)) {
                sleep();
            }
        }
        while (!toolkit.prepareImage(imgRefrOpen, 1, 1, null)) {
            sleep();
        }
    }

    private void sleep() {
        try {
            Thread.sleep(20);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
